Bug 428441 - Expand Settings for Similar Colour Select Tool
Summary: Expand Settings for Similar Colour Select Tool
Status: RESOLVED FIXED
Alias: None
Product: krita
Classification: Applications
Component: Tools/Selection (show other bugs)
Version: 4.4.0
Platform: Microsoft Windows Microsoft Windows
: NOR wishlist
Target Milestone: ---
Assignee: Tiar
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2020-10-29 16:41 UTC by fivetailsfox
Modified: 2020-11-29 21:34 UTC (History)
1 user (show)

See Also:
Latest Commit:
Version Fixed In:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description fivetailsfox 2020-10-29 16:41:50 UTC
Currently in Krita, the Similar Colour Select tool has very minimal settings available, which do not allow it to sample multiple layers like its counterpart the Contiguous Selection tool. This greatly reduces its usefulness when painting with multiple layers as one must manually select each layer in turn and shift-click, keeping track of exactly where in each layer that colour can be found. At this point it is simpler to use the Contiguous Selection instead. I suggest therefore that Similar Colour Select should also have the option to sample from All Layers.
Comment 1 Halla Rempt 2020-10-29 17:01:49 UTC
I discussed that today, and it turns out tiar had this on her todo list already, so we've moved the priority up a notch or two. Thanks for making the report!
Comment 2 Tiar 2020-11-29 21:33:19 UTC
Git commit 6629a8217c6bd70dbb9709756ffccddae468d667 by Agata Cacko.
Committed on 29/11/2020 at 21:30.
Pushed by tymond into branch 'master'.

Multithread KisToolSelectSimilar

Before this commit, KisToolSelectSimilar was not multithreaded.
This commit ensures that KisToolSelectSimilar processes the source
device in patches in multiple threads at once.

Limitation: Color Labeled Layers mode works on the image bounds instead
of the source device bounds.

M  +45   -15   plugins/tools/selectiontools/kis_tool_select_similar.cc

https://invent.kde.org/graphics/krita/commit/6629a8217c6bd70dbb9709756ffccddae468d667
Comment 3 Tiar 2020-11-29 21:33:27 UTC
Git commit 1946c98f6a2a6a9e6c90b03b0c05a64651eebcec by Agata Cacko.
Committed on 29/11/2020 at 21:30.
Pushed by tymond into branch 'master'.

Add missing options to similar color selection tools

Before this commit, similar color selection tool has been
calculated in the GUI thread and lacked both "All layers"
and "Color Labeled Layers" sample options.

This commit adds those options and puts the whole calculation
inside a stroke.

The calculation is not multithreaded yet.

M  +60   -12   plugins/tools/selectiontools/kis_tool_select_similar.cc
M  +1    -0    plugins/tools/selectiontools/kis_tool_select_similar.h

https://invent.kde.org/graphics/krita/commit/1946c98f6a2a6a9e6c90b03b0c05a64651eebcec
Comment 4 Tiar 2020-11-29 21:33:35 UTC
Git commit ff5295f79b2071c3e2df5340801d7673cc3b1468 by Agata Cacko.
Committed on 29/11/2020 at 21:30.
Pushed by tymond into branch 'master'.

Optimize KisToolSelectSimilar for Color Labeled Layers

Before this commit, KisToolSelectSimilar in Color Labeled Layers mode
would use the whole image bounds area to calculate the selection.
This commit ensures that the areas outside of bounds of the source
device are not processed unnecessarily.

M  +4    -1    plugins/tools/selectiontools/kis_tool_select_similar.cc

https://invent.kde.org/graphics/krita/commit/ff5295f79b2071c3e2df5340801d7673cc3b1468
Comment 5 Tiar 2020-11-29 21:34:10 UTC
Git commit 069f558b7df02d6e4d9c7f1c0ee838da4e5e1f1e by Agata Cacko.
Committed on 29/11/2020 at 21:34.
Pushed by tymond into branch 'krita/4.3'.

Add missing options to similar color selection tools

Before this commit, similar color selection tool has been
calculated in the GUI thread and lacked both "All layers"
and "Color Labeled Layers" sample options.

This commit adds those options and puts the whole calculation
inside a stroke.

The calculation is not multithreaded yet.


(cherry picked from commit 1946c98f6a2a6a9e6c90b03b0c05a64651eebcec)

M  +60   -12   plugins/tools/selectiontools/kis_tool_select_similar.cc
M  +1    -0    plugins/tools/selectiontools/kis_tool_select_similar.h

https://invent.kde.org/graphics/krita/commit/069f558b7df02d6e4d9c7f1c0ee838da4e5e1f1e
Comment 6 Tiar 2020-11-29 21:34:31 UTC
Git commit eb235fc0a798fe20b00803a056adcd66b1ee28ff by Agata Cacko.
Committed on 29/11/2020 at 21:34.
Pushed by tymond into branch 'krita/4.3'.

Multithread KisToolSelectSimilar

Before this commit, KisToolSelectSimilar was not multithreaded.
This commit ensures that KisToolSelectSimilar processes the source
device in patches in multiple threads at once.

Limitation: Color Labeled Layers mode works on the image bounds instead
of the source device bounds.


(cherry picked from commit 6629a8217c6bd70dbb9709756ffccddae468d667)

M  +45   -15   plugins/tools/selectiontools/kis_tool_select_similar.cc

https://invent.kde.org/graphics/krita/commit/eb235fc0a798fe20b00803a056adcd66b1ee28ff
Comment 7 Tiar 2020-11-29 21:34:59 UTC
Git commit ab5e7c583a6232713a5261fb803b08bb39619393 by Agata Cacko.
Committed on 29/11/2020 at 21:34.
Pushed by tymond into branch 'krita/4.3'.

Optimize KisToolSelectSimilar for Color Labeled Layers

Before this commit, KisToolSelectSimilar in Color Labeled Layers mode
would use the whole image bounds area to calculate the selection.
This commit ensures that the areas outside of bounds of the source
device are not processed unnecessarily.


(cherry picked from commit ff5295f79b2071c3e2df5340801d7673cc3b1468)

M  +4    -1    plugins/tools/selectiontools/kis_tool_select_similar.cc

https://invent.kde.org/graphics/krita/commit/ab5e7c583a6232713a5261fb803b08bb39619393